;

macro   _16_texels
        i=0
        rept 16
        mov     al, [ebx + ebp]
        add     edx, esi

        adc     bl, dl
        add     eax, ecx

        adc     bh, dh
        mov     [edi + i], al
        i=i+1
        endm
endm

;

global  scan_dest:dword
global  scan_pts:dword
global  scan_proc:dword

global  scanline_buffer[1280]:byte

global  YEnd:dword
global  XPrestep:dword
global  YPrestep:dword

global  OneOverdX:dword
global  OneOverdY:dword
global  X:dword
global  Y:dword
global  OneOverZ:dword
global  U:dword
global  V:dword
global  UOverZ:near
global  VOverZ:near
global  Intens:dword
global  dUdX:dword
global  dVdX:dword
global  dIdX:dword
global  dUdX_int:dword
global  dVdX_int:dword
global  dIdX_int:dword
global  dUdY:dword
global  dVdY:dword
global  dIdY:dword
global  dOneOverZdX:dword
global  dOneOverZdX16:dword
global  dOneOverZdY:dword
global  dUOverZdY:near 
global  dVOverZdY:near
global  dUOverZdX16:dword
global  dVOverZdX16:dword
global  dUOverZdX:near 
global  dVOverZdX:near

global  scan_third:dword
global  scan_half:dword
global  scan_16:dword

global  Ax_Cx:dword
global  Bx_Cx:dword
global  Ay_Cy:dword
global  By_Cy:dword
global  Az_Cz:dword
global  Bz_Cz:dword
global  Au_Cu:dword
global  Bu_Cu:dword
global  Av_Cv:dword
global  Bv_Cv:dword
global  Ai_Ci:dword
global  Bi_Ci:dword

global  YPrestepL1:dword
global  YPrestepL2:dword
global  YPrestepR1:dword
global  YPrestepR2:dword
global  TopSkip:dword
global  BottomSkip:dword
global  Count1:dword
global  Count2:dword
global  leftismiddle:byte

;

macro   get_middle

        xor     ebx, ebx
        fld     [Y + 4]
        fcomp   [Y + 8]
        fnstsw  ax
        and     ah, 41h
        jz      @@rightismiddle

        inc     ebx

@@rightismiddle:
        mov     [leftismiddle], bl

endm

;

macro   make_edges
local   rightismiddle, done

        cmp     [leftismiddle], 1
        jne     rightismiddle

        xor     ebx, ebx
        mov     esi, 8
        mov     edi, o TopToBottom
        call    edge
        xor     ebx, ebx
        mov     esi, 4
        mov     edi, o TopToMiddle
        call    edge
        mov     ebx, 4  
        mov     esi, 8
        mov     edi, o MiddleToBottom
        call    edge
        jmp     done

rightismiddle:
        xor     ebx, ebx
        mov     esi, 4
        mov     edi, o TopToBottom
        call    edge
        xor     ebx, ebx
        mov     esi, 8
        mov     edi, o TopToMiddle
        call    edge
        mov     ebx, 8  
        mov     esi, 4
        mov     edi, o MiddleToBottom
        call    edge

done:

endm

;

macro   topbottom_clip

        xor     eax, eax
        mov     [TopSkip], eax
        mov     [BottomSkip], eax

        mov     eax, [d TopToMiddle + 12]
        mov     ebx, [d MiddleToBottom + 12]
        mov     [Count1], eax
        mov     [Count2], ebx

        mov     eax, [d TopToBottom + 8]
        mov     ebx, [d TopToBottom + 12]
        add     ebx, eax
        mov     edi, eax

        cmp     eax, [zed_bottom]
        jg      done_scan
        sub     eax, [zed_top]
        jge     @@topok

        neg     eax

        add     edi, eax
        mov     [TopSkip], eax

@@topok:
        cmp     ebx, [zed_top]
        jl      done_scan
        sub     ebx, [zed_bottom]
        jle     @@bottomok

        mov     [BottomSkip], ebx

@@bottomok:
        mov     eax, [BottomSkip]
        cmp     eax, [Count2]
        jl      @@onlybottomaffected_bottom

        sub     eax, [Count2]
        sub     [Count1], eax
        mov     eax, [Count2]

@@onlybottomaffected_bottom:
        sub     [Count2], eax

        mov     [YPrestepL2], 0
        mov     [YPrestepR2], 0
        mov     eax, [TopSkip]
        cmp     eax, [Count1]
        jl      @@onlytopaffected_top

        mov     [YPrestepR2], eax
        sub     eax, [Count1]
        mov     [YPrestepL2], eax
        sub     [Count2], eax
        mov     eax, [Count1]

@@onlytopaffected_top:
        sub     [Count1], eax
        mov     [YPrestepL1], eax
        mov     [YPrestepR1], eax

endm

;

macro   draw_toptomiddle  
local   drawloop, done

        mov     ecx, [Count1]
        cmp     ecx, 0  
        jle     done

        call    edge_multi_step

drawloop:
        push    ecx edi
        call    draw_scanline
        pop     edi ecx

        call    edge_step

        add     edi, [mode_bx]
        dec     ecx
        jnz     drawloop

done:

endm

;

macro   draw_middletobottom
local   drawloop, done

        mov     ecx, [Count2]
        cmp     ecx, 0  
        jle     done

        mov     eax, [YPrestepL2]
        mov     ebx, [YPrestepR2]
        mov     [YPrestepL1], eax
        mov     [YPrestepR1], ebx
        call    edge_multi_step

drawloop:
        push    ecx edi
        call    draw_scanline
        pop     edi ecx

        call    edge_step

        add     edi, [mode_bx]
        dec     ecx
        jnz     drawloop

done:

endm

;
